CODE_CHANGES = getGitChanges() // a groovy script could check the git changes and return the boolean 
pipeline{
    agent any
   
    // the environment variables are available in jenkis it self. you can find them in http://127.0.0.1:8080/env-vars.html/ or you can define them like below
    environment {
        NEW_VERSION = '1.3.0'
        SERVER_CREDENTIALS = credentials ('test') // bind credential ("credentialID") to your env variable
    }

// tools provides you with bild tools for your projects. you migth configured some bild tools configure for that. ( Maven, Gradle and jdk available for jenkis
    tools {
        maven Maven ( the name of the tool installed on jenkis server... global tool configuration maven name) this command make maven command available throw all stages
        gradle
        jdk
    }
    // parameters: may be you have some extra configuration in your building environment like selecting which version of the application you want to deploy
    parameters {
        string(name: 'VERSION', defaultValue: '', description: 'version to deploy on prod')
        choice(name: 'VERSION', choices ['1.1.0', '1.2.0', '1.3.0']), description: '')
        booleanParam(name: 'executeTest', defaultValue: true, description '')
            }
    stages {
        stage("build") {
            steps {
                echo 'building the application...'
            }
        }
        stage("test") {
             when {
                expression {
                    BRANCH_NAME == 'master' && CODE_CHANGES == true
                    // this part of pipeline only execute when the branch name is master and scm triggers some changes
                }
            steps {
                echo 'testing the application...'
                echo 'building version ${NEW_VERSION}'
                echo 'building version ${NEW_VERSION}"
                echo "deploying with ${SERVER_CREDENTIALS}" // some basic method to use credential.
                sh "${SERVER_CREDENTIALS"
                // or you can use credential like below. instead of defining it in env block you can directly take it with wrapper
                withCredentials([
                    usernamePassword(credentials: 'test', usernameVariable: USER, passwordVariable: PWD  )
                    // the above 2 lined take user name and passwd and store them in USER and PWD variables
                    // to do so you need to have both credentials and credentials binding plugins on your jenkis server.
                ]) {
                    sh "some script like scp ${USER} ${PWD}"
                }

            }
        }
        stage("deploy") {
            when {
                expression {
                    BRANCH_NAME == 'dev' || BRANCH_NAME == 'master'
                    // this part of pipeline only execute when the branch name is dev
                }
            }
            steps {
                echo 'deploying the application...'
            }
        }
    }
    post {
        always {
            // always executed (sending email...)
        }
        success {
            // execute only when pipeline is succeeded
        }
        failure {
            // execute only when pipeline failed
        }
        stage("final") {
            //testing parameters
            when {
                expression {
                    params.executeTest == true 
                } 
            steps {
                echo 'testing param is done...'
            }
            }
        }
        //we can do all thing with groovy script like bellow
        stage ("pre-testing") {
            steps {
                def function () {
                    echo 'building the application...'
                }
                return 
            }
        }
    }
}
